#property copyright "Copyright 2099, The Clan of Marshmellow Eaters . Inc."
#property version   "1.00"
#property strict

/*
Before you turn this to an indicator you can add the checks required to 
allow your rectangles to extend until they are breached
To do this you will need a list , so first let's take a quick look at that 
Lets say you have 3 people Mike John and Pamela , you are at the door of a room
and you need to log who is in the room at all times .
At first you need the "room" . If you know your "room" can hold up to 5 guests then
you can declare it like that (with 5 positions) 
*/
string guests[5];
/*
this means you can log up to 5 guests , and this is an array 
But what if you don't know how many people are coming and your room has a lot of space ? 
Then you use a dynamic array . so your guest list would look like this 
*/
string more_guests[];
/*
[] brackets to denote a "list" and no number to denote its dynamic and its size will change
So let's assume Pamela shows up , you will need to :
1.get the current size of your list
2.increase it by 1
3.add Pamela to the new slot 
4.you can then return the index of Pamela in the list , or the new size of the list
! like with bars if you have 1 person in your list that person will be in position [0] 
  so the last person in your list is [persons_total-1]
your add function looks like this , straight forward commands luckily.
*/
int add_to_guests(string name_of_new_guest,//the name of the new guest 
                  string &list_to_add_them_into[]){//and the list you want them to be added in ! (so you can reuse it)
int new_size_of_list=ArraySize(list_to_add_them_into);//get the size of the list you want to add them to
    new_size_of_list++;//increase by one 
ArrayResize(list_to_add_them_into,new_size_of_list,0);//expand the list
list_to_add_them_into[new_size_of_list-1]=name_of_new_guest;//and add them to the new position (-1 from total)
//and return the index you added them into to the caller 
return(new_size_of_list-1);    
}
/* piece of cake 
Now what if you want to find someone in the list ?
*/
int find_in_list(string find_who,//the person (or attribute) of what you are looking for
                 string &list_to_lookup[]){//the list you want to check for whether or not they are in 
int found_in=-1;//we reset the found index , so if the caller receives -1 they know nothing was found
//and you simply loop into the list until you hit a match 
  for(int i=0;i<ArraySize(list_to_lookup);i++){
  //easy right ? go into list_to_lookup elements , the index is i and ...
    if(list_to_lookup[i]==find_who){//if the name in the list matches the name we want 
    //we set the found index 
      found_in=i;//as i which is the current index in the loop that matched 
      //and we exit the loop
        break;
    }
  }
//and finally we send what we found , or did not find , to the caller
return(found_in);
}
/* lastly , you may want to remove from a list 
   you will receive an index to remove in the list 
   so :
   1.you get the size of the list 
   2.you reduce it by 1 but don't resize the list yet
   3.you move whatever is in the last position of the list to the position
     you want to remove (overwriting it)
   4.you apply the list size reduction 
   and voilla , you erased an entry from the list
*/
int remove_from_list(int remove_which_index,//the index to be removed 
                     string &the_list[]){//the list
//get the size of the list and reduce by 1
  int new_size=ArraySize(the_list)-1;
//flip the last and the removed positions 
  the_list[remove_which_index]=the_list[new_size];//this is actually the last position which would be total-1 anyway but we have not resized the list yet so it applies to the previous size
//resize the list , caution here you might hit zero size ! so 
  if(new_size>0){//if the new size is > zero
  ArrayResize(the_list,new_size,0);//resize the list
  }
  else{//otherwise free the list
  ArrayFree(the_list);
  }
//and return the new size to the caller 
return(new_size);
}
/* now you can also mix and match 
lets say you want to find a person and delete it 
*/
void search_and_destroy(string for_whom,string &in_list[]){
//you call your finder here 
  int found_in=find_in_list(for_whom,in_list);
  //you send the parameters and receive the result in "found_in" 
  //if its -1 it means that person is not in the list but if not it means they are 
  //hence the following check
    if(found_in!=-1){//if its not -1
    //call the removal function because you now know the index !
      remove_from_list(found_in,in_list);//you don't need the result of that operation
    //and done with lists 
    }
}
/*
So , back to the point .
You need to store your rectangles so that you know :
    a.when they are breached
    b.where they are breached 
    c.display them properly 
therefore you need to store :
    their open and close prices
    their start time 
    their end time 
    their type (1,2)
That means you need 5 lists of the following types :
*/
double open_prices[];
double close_prices[];
datetime start_times[];
datetime end_times[];//no pun
int types[];
/*
but also , thinking ahead you realise you also need to remember which object is 
 "tethered" to what entry so 
*/
string object_tethers[];
/*
and all these lists will 
-work in parallel 
-be maintained 
-contain only the rectangles that are still in play 
So are we going to create functions for each type ?
Nope , we'll jump straight into the deep and create 
your own custom object .
You have an "item" that can be characterized (or identified) by these 5 traits :
 -open price
 -close price
 -start time
 -end time
 -type
 -tethered object
You can declare that , and its functions 
So lets call that "item" a pattern rectangle and add the features 
*/
struct a_pattern_rectangle{
double open_price;
double close_price;
datetime start_time;
datetime end_time;
int type;
string tether;
       /*
       this means you now have your own data type 
       So the same way you would initialize a text variable like so :
       string my_text="michael";
       you will now be able to initialize a pattern rectangle like so :
       a_pattern_rectangle box;
       same thing 
       type variable_name
       you can also decide what the default values are goind to be 
       whenever a variable of "your type" is spawned.
       This is called a constructor . 
       You don't need it currently but it would look like this : 
       */
       a_pattern_rectangle(void){
       open_price=0.0;
       close_price=0.0;
       start_time=0;
       end_time=0;
       type=0;
       tether=NULL;
       }
       /*
       so whenever you created a_pattern_rectangle , it would have these features as defaults 
       But its not required yet so , what would you need ? a set function that changes
       all the features at once , for when you first create your rectangles so : 
       of type void because you don't return anything to the caller 
       */
  void set(double _new_open_price,//the new open price 
           double _new_close_price,//the new close price
           datetime _new_start_time,//the new start time 
           datetime _new_end_time,//the new end time 
           int _new_type,//the type of the pattern
           string _new_tether){//and the new object tether name 
       //and you just pass them into your item 
       open_price=_new_open_price;
       close_price=_new_close_price;
       start_time=_new_start_time;
       end_time=_new_end_time;
       type=_new_type;
       tether=_new_tether;
       //so handy eh ? all in one call 
       }
       /*
       Let's take a pause then , we have your new variable type 
       it has all the features we need 
       we can set all its parameters at once okay .. but 
       we also need to update its end_time , if it is not breached yet.
       Can't it be done by simple passing it in the end_time ? yes 
       but we want something more complete .See we stored the object tether
       so what if you send the new end time and it automatically 
       updates the object too ? neat right ? so : 
       */
  void update_end(datetime _new_end_time){//just the new end time , that is all you need
       //pass it in 
         end_time=_new_end_time;
       //you know the object name ! so update its second time !
         ObjectSetInteger(ChartID(),tether,OBJPROP_TIME2,end_time);
       //done
       }
       /* almost there , what else would be handy if it were """automated""" ?
          how about the check for whether or not the pattern is broken ?
          Well what would we need to send in order to check , given we don't know 
          what type of pattern it is and we'd like to accomodate both types ?
          we can send the high and the low of a bar , these are the edge prices 
          of a bar , and , if we are checking a pattern it means it has not been
          breached yet (its rectangle) so it works for us . 
          And we also require the time why ? to know where to end the rectangle 
          But remember that we can remove from lists too because we are super coders so 
          what if we also return whether or not (true/false) a removal is required from 
          the list this rectangle will be on ? That would be mega handy right ? so : 
       */
  bool check_me(double _high_of_bar,//the high price of a bar 
                double _low_of_bar,//the low price of a bar 
                datetime _time_of_bar){//the time of a bar 
       bool remove_me=false;//we set the removal flag to false 
       /*
       Now what ? 
       We know the prices of the box , and its type 
       type 1 is when the edges are bullish 
       so if type of the pattern (of the rectangle item) is 1
       */
       if(type==1)
         {
         //then we will kill this box if the price goes below the top price 
         //but which price is the top price ? 
           double top_price=MathMax(open_price,close_price);
         //next , which price are we comparing with ? 
         //we are above the box so we use the low 
           //so if the low breaks below the top price we kill the box , easy stuff right ?
             if(_low_of_bar<top_price){//you could also say <= top price 
             remove_me=true;//light up the removal flag
             //set the new end time by using the handy function we built above 
               update_end(_time_of_bar);
             //and that means the rectangle display has been updated 
             }
         }
       //similarly if the box is type 2 bearish edges 
       else if(type==2)
         {
         //you'll do the rest in here ;)
           double top_price=MathMin(open_price,close_price);
         //next , which price are we comparing with ? 
         //we are above the box so we use the low 
           //so if the low breaks below the top price we kill the box , easy stuff right ?
             if(_high_of_bar>top_price){//you could also say <= top price 
             remove_me=true;//light up the removal flag
             //set the new end time by using the handy function we built above 
               update_end(_time_of_bar);
             //and that means the rectangle display has been updated 
             }         
         }
       /*
       at this point we are done with the variable type 
       all else will be taken care of on the list of these items 
       */      
       return(remove_me);
       }
};
/*
Now we could go ahead and create another object which has these objects inside and manages them 
but for simplicity sake we will just replicate the list management functions but with the new 
order type so first we will need a permanent list of your variable type :
*/
a_pattern_rectangle myBoxes[];//and its a dynamic list 
//what comes first ? adding to the list 
//similarly as above but we send the feature of the box in the add call , instead of the one name which was the only feature in the guests example
//so : 
int add_a_box(a_pattern_rectangle &box_list[],//first the boxes list we are going to add the box to 
              double _new_open_price,//then the features , this resembles the set function above 
              double _new_close_price,
              datetime _new_start_time,
              datetime _new_end_time,
              int _new_type,
              string _new_tether){
//this is the easy one i'll let you do it ;) 
int ns=ArraySize(box_list)+1;
ArrayResize(box_list,ns,0);
box_list[ns-1].set(_new_open_price,_new_close_price,_new_start_time,_new_end_time,_new_type,_new_tether);
return(ns-1);
}
//we wont need to find any boxes in this program , luckily ... :P 
//but we will remove so :
int remove_box(a_pattern_rectangle &from_this_box_list[],//the box list to remove the box from
               int box_position_to_remove){//the position of the box we want to remove
               //just like in the example then 
//get the size of the list and reduce by 1
  int new_size=ArraySize(from_this_box_list)-1;
//flip the last and the removed positions 
  from_this_box_list[box_position_to_remove]=from_this_box_list[new_size];//this is actually the last position which would be total-1 anyway but we have not resized the list yet so it applies to the previous size
//resize the list , caution here you might hit zero size ! so 
  if(new_size>0){//if the new size is > zero
  ArrayResize(from_this_box_list,new_size,0);//resize the list
  }
  else{//otherwise free the list
  ArrayFree(from_this_box_list);
  }
//and return the new size to the caller 
return(new_size); 
}
//and finally we will need to manage the list of the boxes 
/*
so when will we manage the list ? 
On each new bar , including the bars of the past 
So again what data points are we going to need ?
the high , low and time of the recently formed bar 
so here goes :
*/
void manage_boxes(a_pattern_rectangle &of_this_list[],//right ? the list of the boxes to manage
                  double _bar_high,//the high of the recently formed bar 
                  double _bar_low,//the low of the recently formed bar 
                  datetime _bar_time){//and the time of the recently formed bar
/*
we will be removing boxes so we will check from the bottom to the top 
so that we don't skip a check after a removal (You can think why that is)

*/
//set the loop start then , recall that items start from [0] and not [1] so they end at [total_items-1] 
//that is our start 
  int from=ArraySize(of_this_list)-1;//the size of this list -1 , which is the last item 
  //and we will loop until we hit 0 (the first item) reducing the position checked at each step
    for(int i=from;i>=0;i--)
    {
    //what do we do now ? call the check and receive whether or not we need to remove the box from the list 
      bool remove_this=of_this_list[i].check_me(_bar_high,_bar_low,_bar_time);
      //should we remove this ?
        if(remove_this)
          {
          //and we know its index , its i , so remove i from the list ,kidsplay  
            remove_box(of_this_list,i);
            //the box is removed from the list 
            //its display is updated automatically 
            //and done ... that's it 
            //notice how the more work we do on the foundation 
            //the less and cleaner the code looks at the top
          }
    }
}

bool myown_pattern(int rightmost_bar_of_the_pattern,
                        double &open_result,
                        double &close_result,
                        int &type_result)
{
 bool result=false;
 type_result=0;
       int x=rightmost_bar_of_the_pattern;
       //so [5]=[x+4] [4]=[x+3]
     if(Close[x+4]>Open[x+4] && Close[x+3]>Open[x+3])
       {
           // [3]=[x+2] 
           if(Close[x+2]<Open[x+2])
             {
             //[2]=[x+1] [1]=[x]
               if(Close[x+1]>Open[x+1] && Close[x]>Open[x])
                 {
                   result=true; 
                       open_result=Open[x+2];
                       close_result=Close[x+2]; 
                       type_result=1;
                 }
             } 
       }
       
       if(Close[x+4]<Open[x+4] && Close[x+3]<Open[x+3])
       {
           // [3]=[x+2] 
           if(Close[x+2]>Open[x+2])
             {
             //[2]=[x+1] [1]=[x]
               if(Close[x+1]<Open[x+1] && Close[x]<Open[x])
                 {
                   result=true;
                       open_result=Open[x+2];
                       close_result=Close[x+2];
                       type_result=2;
                 }
             } 
       } 
   
 return(result);
}

datetime barstamp=0;
int rectangles_total=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
    barstamp=0;
    rectangles_total=0;
     int total_bars=Bars;
     int check_from=total_bars-1-5; 
     int check_until=1;
     ObjectsDeleteAll(ChartID(),"PATTERN_");
     for(int i=check_from;i>=check_until;i--)
      {
      //we run a lil check on our boxes list 
        manage_boxes(myBoxes,High[i],Low[i],Time[i]);//we send the data of the recently formed bar
        double open_price=0.0;
      //the close price 
        double close_price=0.0;
        int pattern_type=0;
        if(myown_pattern(i,open_price,close_price,pattern_type))
        {
        datetime start_time=0;
        datetime end_time=0;
        end_time=Time[i];//the end time is i , and it will expand later
        start_time=Time[i+2];//the start time is the middle bar so i+2
        rectangles_total=rectangles_total+1;
          string the_rectangles_name="PATTERN_"+IntegerToString(rectangles_total);
          ObjectCreate(ChartID(),the_rectangles_name,OBJ_RECTANGLE,0,start_time,open_price,end_time,close_price); 
            color rectangle_color=clrGreen;
            if(pattern_type==2){rectangle_color=clrRed;}
            ObjectSetInteger(ChartID(),the_rectangles_name,OBJPROP_COLOR,rectangle_color);          
        //the addition here is we create a new object in our list 
          /*
          we send all the parameters we just found and we log it in our list so that 
          we can check it later on 
          */
          add_a_box(myBoxes,open_price,close_price,start_time,end_time,pattern_type,the_rectangles_name);
        }
        barstamp=Time[i];
      }
  return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

  if(Time[1]>barstamp)
  {

    barstamp=Time[1];

        double open_price=0.0;
        double close_price=0.0;
        int pattern_type=0;
        
        if(myown_pattern(1,open_price,close_price,pattern_type))
        {
        datetime start_time=Time[5];
        datetime end_time=Time[1];
        rectangles_total=rectangles_total+1;
        string the_rectangles_name="PATTERN_"+IntegerToString(rectangles_total);
        ObjectCreate(ChartID(),the_rectangles_name,OBJ_RECTANGLE,0,start_time,open_price,end_time,close_price);
        color rectangle_color=clrGreen;
        if(pattern_type==2){rectangle_color=clrRed;}
        ObjectSetInteger(ChartID(),the_rectangles_name,OBJPROP_COLOR,rectangle_color);          
        }    
  }
   
  }
  